<template>
  <div class="container-fluid">
    <div class="row">
      <admin-title-bar :title="title">
        <nuxt-link :to="{name: 'admin-products-category-new'}">
          <el-button type="success">جدید</el-button>
        </nuxt-link>
      </admin-title-bar>
      <div class="col-12">
        <admin-panel>
          <el-table
              :data="categories"
              style="width: 100%">
            <el-table-column
                type="index"
                label="#">
            </el-table-column>

            <el-table-column
                prop="category_details.fa.name"
                label="نام دسته بندی"
                width="">
            </el-table-column>

            <el-table-column
                label="ویرایش"
                width="150"
                align="left">
              <template slot-scope="scope">
                <el-button type="warning" plain icon="el-icon-edit" @click="edit(scope.row._id)"></el-button>
                <el-button type="danger" plain icon="el-icon-delete" @click="del(scope.row._id)"></el-button>
              </template>
            </el-table-column>

          </el-table>
        </admin-panel>
      </div>
    </div>
  </div>
</template>


<script>
export default {
  data() {
    return {
      title: 'دسته بندی محصولات',
      categories: null
    }
  },
  head() {
    return {
      title: this.title,
    }
  },
  methods: {
    edit(id) {
      this.$router.push(`/admin/products/category/${id}`)
    },
    del(id) {
      this.$confirm('این آیتم حذف شود؟', 'هشدار', {
        confirmButtonText: 'بله',
        cancelButtonText: 'لغو',
        type: 'warning'
      }).then(() => {
        this.$axios.delete(`/api/private/productCategories/${id}`)
            .then(response => {
              this.categories = this.categories.filter(item => {
                return item._id !== id
              })
              this.$message({
                type: 'success',
                message: 'آیتم حذف شد'
              })
            })
            .catch(err => {
              this.$message({
                type: 'error',
                message: err.response.data.message
              })
            })
      }).catch(() => {
        this.$message({
          type: 'warning',
          message: 'عملیات لغو شد'
        });
      });
    }
  },
  layout: 'admin',
  async asyncData({$axios, error}) {
    try {
      let categories = await $axios.get(`/api/public/productCategories`);
      return {
        categories: categories.data
      }
    } catch (e) {
      error({status: 404, message: 'There is a problem here'})
    }
  }
}
</script>
